 /*
  * Khoros: $Id: kinstall.h,v 1.2 1991/10/02 00:00:36 khoros Exp $
  */

 /*
  * $Log: kinstall.h,v $
 * Revision 1.2  1991/10/02  00:00:36  khoros
 * HellPatch2
 *
  */

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as to the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including, for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: kinstall.h
 >>>>            Author: Tom Sauer and Charlie Gage
 >>>> Date Last Updated: Wed Sep 25 22:11:09 1991
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _kinstall_h_
#define _kinstall_h_

#include "vinclude.h"


/* -include_includes */
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program;	/* a pointer to the program name argv[0] */
int	ac;

/****************************************************************
*
*                    kinstall Argument Structure
*
****************************************************************/

typedef struct _kinstall  {

/*
 *  program name (Required string)
 */
char	*name_string;	/* program name STRING */
int	 name_flag;   	/* program name FLAG */

/*
 *  input config file (Required infile)
 */
char	*conf_file;	/* input config file FILENAME */
int	 conf_flag;	/* input config file FLAG */

/*
 *  input toolbox name (Optional string)
 */
char	*toolbox_string;	/* input toolbox name STRING */
int	 toolbox_flag;   	/* input toolbox name FLAG */

/*
 *  fprog option (Optional logical)
 */
int	 fprog_logic;	/* fprog option LOGIC */
int	 fprog_flag;  	/* fprog option FLAG */

/*
 *  Force option (Optional logical)
 */
int	 force_logic;	/* Force option LOGIC */
int	 force_flag;  	/* Force option FLAG */

}  kinstall_struct;

kinstall_struct *kinstall;

/* -include_additions */
#include "ghost.h"
/* Let each argument passed to the script file have 500 bytes */
#define BUFSIZE 500*16
/* -include_additions_end */

/* -include_macros */
/* -include_macros_end */

#endif
