 /*
  * Khoros: $Id: vlaser.h,v 1.1 1991/05/10 15:50:49 khoros Exp $
  */

 /*
  * $Log: vlaser.h,v $
 * Revision 1.1  1991/05/10  15:50:49  khoros
 * Initial revision
 *
  */ 

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as too the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: vlaser.h
 >>>>            Author: Scott Wilson, Mark Young
 >>>> Date Last Updated: Thu Mar 28 00:09:45 1991
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _vlaser_h_
#define _vlaser_h_

#include "vinclude.h"


/* -include_includes */
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program,	/* a pointer to the program name argv[0] */
	*calloc();
int	ac;

/****************************************************************
*
*                    vlaser Argument Structure
*
****************************************************************/

typedef struct _vlaser  {

/*
 *  input image filename (Required infile)
 */
char	*i_file;	/* input image filename FILENAME */
int	 i_flag;	/* input image filename FLAG */

/*
 *  mag factor = 2**(specifed mag amount) (Optional integer)
 */
int	 m_int; 	/* mag factor = 2**(specifed mag amount) INT */
int	 m_flag;	/* mag factor = 2**(specifed mag amount) FLAG */

/*
 *  x offset in inches from upper left corner (Optional float)
 */
float	 x_float;	/* x offset in inches from upper left corner FLOAT */
int	 x_flag;   	/* x offset in inches from upper left corner FLAG */

/*
 *  y offset in inches from upper left corner (Optional float)
 */
float	 y_float;	/* y offset in inches from upper left corner FLOAT */
int	 y_flag;   	/* y offset in inches from upper left corner FLAG */

/*
 *  Photonegative output (Optional logical)
 */
int	 p_logic;	/* Photonegative output LOGIC */
int	 p_flag;  	/* Photonegative output FLAG */

}  vlaser_struct;

vlaser_struct *vlaser;

/* -include_additions */
/* -include_additions_end */

/* -include_macros */
#define CHECKINPUT(program, img1) \
        (void) proper_num_images(program,img1,1,TRUE); \
        (void) proper_num_bands(program,img1,1,TRUE); \
        (void) propertype(program,img1,VFF_TYP_BIT,TRUE); \
        (void) proper_map_enable(program,img1,VFF_MAP_OPTIONAL,TRUE)
/* -include_macros_end */

#endif
