 /*
  * Khoros: $Id: actions.h,v 1.2 1991/10/02 00:17:21 khoros Exp $
  */

 /*
  * $Log: actions.h,v $
 * Revision 1.2  1991/10/02  00:17:21  khoros
 * HellPatch2
 *
  */ 

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1990, University of New Mexico.  All rights reserved.
 * 
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as too the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *----------------------------------------------------------------------
 */

#include "unmcopyright.h"	 /* Copyright 1990 by UNM */

#ifndef _actions_h_
#define _actions_h_

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>                                                          <<<<
   >>>>	     file: actions.h					 <<<<
   >>>>                                                          <<<<
   >>>>      contains: Action Records                            <<<<
   >>>>                                                          <<<<
   >>>>      These are the action record tables that are used    <<<<
   >>>>      with the routines in createwid.c 			 <<<<
   >>>>                                                          <<<<
   >>>>      written by: Danielle Argiro                         <<<<
   >>>>                                                          <<<<
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */


/* 
 * Special translation table used for ints with scroll bars 
 * ("live" or not) -  Map <CR> to update scroll bar,
 * and control-X to go to beginning of text widget. 
 */
XtActionsRec intscroll_actionTable[] =
{
  { "xvf_update_int_scroll",  xvf_update_int_scroll},
};

/* 
 * Special translation table used for floats with scroll bars-
 * Map <CR> to update scroll bar,
 * and control-X to go to beginning of text widget. 
 */
XtActionsRec float_actionTable[] =
{
  { "xvf_update_float_scroll",  xvf_update_float_scroll},
};

/* 
 * Special translation table used for live ints without scroll bars-
 * Map <CR> to update scroll bar,
 * and control-X to go to beginning of text widget. 
 */
XtActionsRec liveint_actionTable[] =
{
  { "xvf_return_live_int",  xvf_return_live_int},
};

/* 
 * Special translation table used for live ints without scroll bars-
 * Map <CR> to update scroll bar,
 * and control-X to go to beginning of text widget. 
 */
XtActionsRec livefloat_actionTable[] =
{
  { "xvf_return_live_float",  xvf_return_live_float},
};

/*
 * Special translation table used for live string selections -
 * Map <CR> to return to application,
 * and control-X to go to beginning of text widget.
 */
XtActionsRec livestring_actionTable[] =
{
  { "xvf_return_live_string",  xvf_return_live_string},
};

/*
 * Special translation table used for live output selections -
 * Map <CR> to return to application,
 * and control-X to go to beginning of text widget.
 */
XtActionsRec liveoutput_actionTable[] =
{
  { "xvf_return_live_outfile",  xvf_return_live_outfile},
};

/*
 * Special translation table used for live inputfile selections -
 * Map <CR> to return to application,
 * and control-X to go to beginning of text widget.
 */
XtActionsRec liveinput_actionTable[] =
{
  { "xvf_return_live_infile",  xvf_return_live_infile},
};

/*
 * Special translation table used for AnswerInfile selections -
 * Map <CR> to call xvf_update_forms_from_answerfile();
 * and control-X to go to beginning of text widget.
 */
XtActionsRec ansinfile_actionTable[] =
{
  { "xvf_update_forms_from_answerfile",  xvf_update_forms_from_answerfile},
};

/*
 * Special translation table used for AnswerOutfile selections -
 * Map <CR> to call xvf_update_answerfile_from_forms();
 * and control-X to go to beginning of text widget.
 */
XtActionsRec ansoutfile_actionTable[] =
{
  { "xvf_update_answerfile_from_forms",  xvf_update_answerfile_from_forms},
};
#endif
/* Don't add after this line */

