 /*
  * Khoros: $Id: iconimage.h,v 1.4 1992/03/20 22:50:48 dkhoros Exp $
  */

 /*
  * $Log: iconimage.h,v $
 * Revision 1.4  1992/03/20  22:50:48  dkhoros
 * VirtualPatch5
 *
  */

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1992, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as to the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including, for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1992 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: iconimage.h
 >>>>            Author: Mark Young and Stephanie Hallet
 >>>> Date Last Updated: Fri Feb 28 15:32:52 1992
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _iconimage_h_
#define _iconimage_h_

#include "xvinclude.h"


/* -include_includes */
#include "xvforms.h"
#include "xvdisplay.h"
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program;	/* a pointer to the program name argv[0] */
int	ac;

/****************************************************************
*
*                    iconimage Argument Structure
*
****************************************************************/

typedef struct _iconimage  {

/*
 *  input image filename (Required infile)
 */
char	*i;     	/* input image filename FILENAME */
int	 i_flag;	/* input image filename FLAG */

/*
 *  overlay image filename (Optional infile)
 */
char	*ov;     	/* overlay image filename FILENAME */
int	 ov_flag;	/* overlay image filename FLAG */

/*
 *  input shape mask filename (Optional infile)
 */
char	*s;     	/* input shape mask filename FILENAME */
int	 s_flag;	/* input shape mask filename FLAG */

/*
 *  input clip mask filename (Optional infile)
 */
char	*c;     	/* input clip mask filename FILENAME */
int	 c_flag;	/* input clip mask filename FLAG */

/*
 *  x value of upper-left corner of icon (Optional integer)
 */
int	 x;    	/* x value of upper-left corner of icon INT */
int	 x_flag;	/* x value of upper-left corner of icon FLAG */

/*
 *  y value of upper-left corner of icon (Optional integer)
 */
int	 y;    	/* y value of upper-left corner of icon INT */
int	 y_flag;	/* y value of upper-left corner of icon FLAG */

/*
 *  width of icon image in pixels (Optional integer)
 */
int	 w;    	/* width of icon image in pixels INT */
int	 w_flag;	/* width of icon image in pixels FLAG */

/*
 *  height of icon image in pixels (Optional integer)
 */
int	 h;    	/* height of icon image in pixels INT */
int	 h_flag;	/* height of icon image in pixels FLAG */

/*
 *  update time (Optional float)
 */
float	 update;      	/* update time FLOAT */
int	 update_flag;   	/* update time FLAG */

/*
 *  host:display.screen (Optional string)
 */
char	*display;       	/* host:display.screen STRING */
int	 display_flag;   	/* host:display.screen FLAG */

/*
 *  use colormap? (Optional logical)
 */
int	 use_cmap;      	/* use colormap? LOGIC */
int	 use_cmap_flag;  	/* use colormap? FLAG */

}  iconimage_struct;

iconimage_struct *iconimage;

/* -include_additions */

int     ICONIMAGE_DONE;

/* -include_additions_end */

/* -include_macros */
/* -include_macros_end */

#endif
