 /*
  * Khoros: $Id: kraftsman.h,v 1.4 1992/03/20 22:53:00 dkhoros Exp $
  */

 /*
  * $Log: kraftsman.h,v $
 * Revision 1.4  1992/03/20  22:53:00  dkhoros
 * VirtualPatch5
 *
  */

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as to the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including, for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: kraftsman.h
 >>>>            Author: Steven Jorgensen 
 >>>> Date Last Updated: Fri Dec 13 15:03:08 1991
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _kraftsman_h_
#define _kraftsman_h_

#include "xvinclude.h"


/* -include_includes */
#include "xvforms.h"
#include "toolboxes.h"
#include "form_info.h"
#include "configtb.h"
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program;	/* a pointer to the program name argv[0] */
int	ac;

/****************************************************************
*
*                    kraftsman Argument Structure
*
****************************************************************/

typedef struct _kraftsman  {

/*
 *  Tool box (Optional string)
 */
char	*toolbox_string;	/* Tool box STRING */
int	 toolbox_flag;   	/* Tool box FLAG */

}  kraftsman_struct;

kraftsman_struct *kraftsman;

/* -include_additions */
Display *display;
xvf_form  *form;
Master Master_info;
char **_parsedirs();
char *_expandinternals();
char *_getnextvar();
char *vcomposepath();
int vmkdir();
void _xv_perror_wait();
/* -include_additions_end */

/* -include_macros */
#ifdef LOCAL
#  define CFGFILE "KHOROS_HOME/work/xvroutines/kraftsman/config/km.config"
#  define CFGPATH "KHOROS_HOME/work/xvroutines/kraftsman/config"
#else
#  define CFGFILE "KHOROS_HOME/repos/config/kraftsman/km.config"
#  define CFGPATH "KHOROS_HOME/repos/config/kraftsman"
#endif
/* -include_macros_end */

#endif
